uniform sampler2D u_texture0;

uniform float u_threshold;
uniform vec4 u_fg_color;
uniform vec4 u_bg_color;

varying vec2 v_texCoord0;

void main() {
    float distance = texture2D(u_texture0, v_texCoord0).a;

  	float width = fwidth(distance);
    float alpha = smoothstep(u_threshold - width, u_threshold + width, distance);
    
    gl_FragColor = vec4(mix(u_bg_color, u_fg_color, alpha));
}